#include "game.h"
#include<stdio.h>
#include<stdlib.h>
#include<stdbool.h>
#include<time.h>
#include"piece.h"
#include<string.h>

piece* creat_tab(int i, int x, int y){
  srand(time(NULL));
  bool inter = false;
  piece* pieces = malloc(sizeof(piece)*(i));
  int j = 1;
  *pieces = new_piece(rand()%(x-2), rand()%(y-2),2,2, true, true);
  while(j<i){
    if(rand()%3 == 2){
      *(pieces+j) = new_piece(rand()%(x-1), rand()%(y-2),1,2, true, true);
    }
    else if(!rand()%3){
      *(pieces+j) = new_piece(rand()%(x-2), rand()%(y-1),2,1, true, true);
    }
    else{
      *(pieces+j) = new_piece(rand()%(x-1), rand()%(y-1),1,1, true, true);
    }
    for(int k = 0; k<j; k++){
      if(intersect(*(pieces+j), *(pieces+k))){
	  inter = true;
      }
    }
    if(!inter){
      j++;
    }
    inter = false;
  }
  return pieces;
}

void display(game g){
  int **t;
  t = malloc(sizeof(*t)*game_width(g));
  for(int h = 0 ; h<game_height(g); h ++){
    t[h]= malloc(sizeof(*(t[h]))*game_height(g));
  }
  for(int x = 0; x<game_width(g); x++){
    for(int y = 0; y<game_height(g); y++){
      t[x][y] = -1;
    }
  }
  for(int k = 0; k<game_nb_pieces(g); k++){
    for(int x = 0; x<game_width(g); x++){
      for(int y= 0; y<game_height(g); y++){
        if(get_x(game_piece(g,k)) == x && get_y(game_piece(g,k)) == y){
	  for(int i = x; i-x < get_width(game_piece(g,k)); i++){
            for(int j = y; j-y < get_height(game_piece(g,k)); j++){
              t[i][j] = k;
	    }
	  }
	}
      }
    }
  }
  printf("#");
  for(int o = 0 ;o<game_width(g);o++){
    printf("#");
  }
  printf("#\n");
  for(int y = game_height(g)-1; y>=0; y--){
    printf("#");
    for(int x = 0; x<game_width(g); x++){
      if(t[x][y] == -1){
        printf(".");
      }
      else{
        printf("%d",t[x][y]);
      }
    }
    printf("#\n");
  }
  printf("#");
  for(int o = 0 ;o<game_width(g);o++){
    if(o == 3 || o==4){
      printf(" ");
    }
    else{
      printf("#");
    }
  }
  printf("#\n");
  for(int h = 0 ; h<game_height(g); h ++){ 
    free(t[h]);
  }
  free(t);
}

int main(){
  piece* tab_pieces = malloc(sizeof(*tab_pieces)*10);
  if(tab_pieces == NULL){
    return 1;
  }
  char* i = malloc(sizeof(*i)*10);
  if(i == NULL){
    return 1;
  }
  char* j = malloc(sizeof(*i)*10);
  if(i == NULL){
    return 1;
  }
  char* k = malloc(sizeof(*i)*10);
  if(i == NULL){
    return 1;
  }
  bool end = false;
  char* direction = malloc(sizeof(*direction)*10);
  if(direction == NULL){
    return 1;
  }
  char* piece = malloc(sizeof(*piece)*10);
  if(piece == NULL){
    return 1;
  }
  char* distance = malloc(sizeof(*distance)*10);
  if(distance == NULL){
    return 1;
  }
  dir v;
  while(true){
    end = false;
    printf("\nCombien de pièces ? (entre 1 et 10) -> ");
    scanf("%c",i);
    while(atoi(i)<=0 || atoi(i)>10){
      printf("Nombre incorrect !\n");
      printf("\nVeuillez entrer un nouveau nombre: -> ");
      scanf("%c",i);
    }
    printf("\nQuelle longueur de plateau ? (entre 7 et 9) -> ");
    scanf("%c",j);
    while(atoi(j)<=6 || atoi(j)>20){
      printf("Taille incorrecte !\n");
      printf("\nVeuillez entrer un nouveau nombre: -> ");
      scanf("%c",j);
    }
    printf("\nQuelle hauteur de plateau ? (entre 7 et 9) -> ");
    scanf("%c",k);
    while(atoi(k)<=6 || atoi(k)>20){
      printf("Taille incorrecte !\n");
      printf("\nVeuillez entrer un nouveau nombre: -> ");
      scanf("%c",k);
    }
    tab_pieces = creat_tab(atoi(i),atoi(j),atoi(k));
    game g = new_game(atoi(j),atoi(k),atoi(i), tab_pieces);
    printf("\n\n\n\n\n\n\n");
    display(g);
    printf("\n\n\n\n\n\n\n");
    while(!game_over(g) && !end){
      printf("Nombre de mouvements: %d\n", game_nb_moves(g));
      printf("\nChoisissez une pièce: -> ");
      scanf("%s",piece);
      if(strcmp(piece,"q")!=0){
	printf("\n\n\n\n\n\n\n");
	display(g);
	printf("\n\n\n\n\n\n\n");
	printf("Nombre de mouvements: %d\n", game_nb_moves(g));
        printf("\nChoisissez sa direction: -> ");
        scanf("%s",direction);
	if(strcmp(piece,"q")!=0){
	  printf("\n\n\n\n\n\n\n");
	  display(g);
	  printf("\n\n\n\n\n\n\n");
	  printf("Nombre de mouvements: %d\n", game_nb_moves(g));
	  printf("\nDe combien de cases ? -> ");
	  scanf("%s",distance);
	  printf("%s\n",direction);
	  if(strcmp(distance,"q") != 0){
	    if(!strcmp(direction,"RIGHT")){
	      v =RIGHT;
	      play_move(g,atoi(piece),v,atoi(distance));
	    }
	    if(!strcmp(direction,"LEFT")){
	      v =LEFT;
	      play_move(g,atoi(piece),v,atoi(distance));
	    }  
	    if(!strcmp(direction,"UP")){
	      v =UP;
	      play_move(g,atoi(piece),v,atoi(distance));
	    }
	    if(!strcmp(direction,"DOWN")){
	      v =DOWN;
	      play_move(g,atoi(piece),v,atoi(distance));
	    }
	    printf("\n\n\n\n\n\n\n");
	    display(g);
	    printf("\n\n\n\n\n\n\n");
	  }
	  else{
            end = true;
	  }
	}    
	else{
          end = true;
	}
      }
      else{
        end = true;
      }
    }
    if(game_over(g)){
      printf("\nC'est gagné !!\n");
    }
    else{
      printf("\nDéjà marre ?\n");
    }
    delete_game(g);
    for(int o = 0; o <= atoi(i); o++){
	delete_piece(tab_pieces[o]);
    }
    printf("Une nouvelle partie ? y/n -> ");
    char* reponse = malloc(sizeof(*reponse)*10);
    if(reponse == NULL){
      return 1;
    }
    scanf("%s",reponse);
    if(!strcmp(reponse,"n")){
      free(direction);
      free(distance);
      free(piece);
      free(i);
      free(j);
      free(k);
      free(reponse);
      free(tab_pieces);
      return 0;
    }
  }
}
